format long 
precision = 20;

Ain = problem.mpc_constraints.Ain;
bin = problem.mpc_constraints.bin;
cin = problem.mpc_constraints.cin;
f   = problem.mpc_cost.f;

%% bin

string_bin = 'c_float bindata[';
string_bin = strcat(string_bin, num2str(size(bin,1), precision));
string_bin = strcat(string_bin, '] = {');
for i = 1:size(bin,1)
    string_bin = strcat(string_bin, '(c_float)');
    string_bin = strcat(string_bin, num2str(bin(i), precision));
    string_bin = strcat(string_bin, ',');
end
string_bin = strcat(string_bin, '};');

%% cin

string_cin = 'c_float cindata[';
string_cin = strcat(string_cin, num2str(size(cin,1), precision));
string_cin = strcat(string_cin, '][');
string_cin = strcat(string_cin, num2str(size(cin,2), precision));
string_cin = strcat(string_cin, '] = {');
for i = 1:size(cin,1)
    string_cin = strcat(string_cin, '{');
    for j = 1:size(cin,2)             
        string_cin = strcat(string_cin, '(c_float)');
        string_cin = strcat(string_cin, num2str(cin(i,j), precision));
        string_cin = strcat(string_cin, ',');
    end
    string_cin = strcat(string_cin, '} ,');
end    
string_cin = strcat(string_cin, '};');

%% f

string_f = 'c_float fdata[';
string_f = strcat(string_f, num2str(size(f,1), precision));
string_f = strcat(string_f, '][');
string_f = strcat(string_f, num2str(size(f,2), precision));
string_f = strcat(string_f, '] = {');
for i = 1:size(f,1)
    string_f = strcat(string_f, '{');
    for j = 1:size(f,2)             
        string_f = strcat(string_f, '(c_float)');
        string_f = strcat(string_f, num2str(f(i,j), precision));
        string_f = strcat(string_f, ',');
    end
    string_f = strcat(string_f, '} ,');
end    
string_f = strcat(string_f, '};');

%% Su

string_Su = 'c_float Sudata[';
string_Su = strcat(string_Su, num2str(size(Su,1), precision));
string_Su = strcat(string_Su, '][');
string_Su = strcat(string_Su, num2str(size(Su,2), precision));
string_Su = strcat(string_Su, '] = {');
for i = 1:size(Su,1)
    string_Su = strcat(string_Su, '{');
    for j = 1:size(Su,2)             
        string_Su = strcat(string_Su, '(c_float)');
        string_Su = strcat(string_Su, num2str(Su(i,j), precision));
        string_Su = strcat(string_Su, ',');
    end
    string_Su = strcat(string_Su, '} ,');
end    
string_Su = strcat(string_Su, '};');

%% Sx

string_Sx = 'c_float Sxdata[';
string_Sx = strcat(string_Sx, num2str(size(Sx,1), precision));
string_Sx = strcat(string_Sx, '][');
string_Sx = strcat(string_Sx, num2str(size(Sx,2), precision));
string_Sx = strcat(string_Sx, '] = {');
for i = 1:size(Sx,1)
    string_Sx = strcat(string_Sx, '{');
    for j = 1:size(Sx,2)             
        string_Sx = strcat(string_Sx, '(c_float)');
        string_Sx = strcat(string_Sx, num2str(Sx(i,j), precision));
        string_Sx = strcat(string_Sx, ',');
    end
    string_Sx = strcat(string_Sx, '} ,');
end    
string_Sx = strcat(string_Sx, '};');

%% makro for number of constraints and number of inequality constraints

makro_num_constr = '#define NUM_CONSTRAINTS';
makro_num_constr = [makro_num_constr ' ' num2str(size(Ain, 1))];
makro_length_z = '#define LENGTH_Z';
makro_length_z = [makro_length_z ' ' num2str(size(Ain,2))];
makro_length_x = '#define LENGTH_X';
makro_length_x = [makro_length_x ' ' num2str(system.n * system.N)];
makro_length_u = '#define LENGTH_U';
makro_length_u = [makro_length_u ' ' num2str(system.m * system.N)];

%% add to workspace.h
clear A_info


file_name = 'workspace.h';

% read file
fid       = fopen(file_name, 'r');
tline     = 'none';
last_line = '&settings, &scaling, &solution, &info};';
i         = 0;
while ~(strcmp(cellstr(tline(1,:)),last_line))
    i          = i + 1;
    tline      = fgets(fid);
    A_info{i}  = tline;
end
end_file = i;
fclose(fid);
% write to file
fid = fopen(file_name, 'w+');
for i = 1:end_file+9
    if (i < end_file+1)
        fprintf(fid, '%s', A_info{i});
    elseif (i == end_file+1)
        fprintf(fid, '\n%s', string_bin);
    elseif (i == end_file+2)
        fprintf(fid, '\n%s', string_cin);
    elseif (i == end_file+3)
        fprintf(fid, '\n%s', string_f);
    elseif (i == end_file+4)
        fprintf(fid, '\n%s', string_Su);
    elseif (i == end_file+5)
        fprintf(fid, '\n%s', string_Sx);
    elseif (i == end_file+6)
        fprintf(fid, '\n%s', makro_num_constr);
    elseif (i == end_file+7)
        fprintf(fid, '\n%s', makro_length_z);
    elseif (i == end_file+8)
        fprintf(fid, '\n%s', makro_length_x);
    elseif (i == end_file+9)
        fprintf(fid, '\n%s', makro_length_u);                
    end
end
fclose(fid);

current_path = pwd;
copyfile([current_path '\workspace.h'], ...
         [current_path '\' dir_name '\include\workspace.h']);
copyfile([current_path '\workspace.h'], ...
         [current_path '\' dir_name '\src\osqp\workspace.h']);