% process noise
w_travel          = 0.35;   % for travel
w_travel_rate     = 0.1;    % for travel rate
w_pitch           = 0.32;  % for pitch
w_pitch_rate      = 0.41;   % for pitch rate
w_elevation       = 0.2;    % for elevation
w_elevation_rate  = 0.1;    % for elevation rate
w_dist            = 0.001;   % for modelled disturbance
% measurement noise
v_travel          = 0.02;   % for travel
v_travel_rate     = 0.01;   % for travel rate
v_pitch           = 0.06;   % for pitch
v_pitch_rate      = 0.07;   % for pitch rate
v_elevation       = 0.012;  % for elevation
v_elevation_rate  = 0.01;   % for elevation rate


% generate matrices Q_K, R_K
estimator.Q_K = diag([w_travel    w_travel_rate    ...
            w_pitch     w_pitch_rate     ...
            w_elevation w_elevation_rate ...
            w_dist]);

% measurement noise covariance matrix
estimator.R_K = diag([v_travel    v_travel_rate ...
            v_pitch     v_pitch_rate  ...
            v_elevation v_elevation_rate]);
            
% calculate Kalman filter gain
plant = ss(system.A, [system.B system.G], system.C, [system.D system.H], -1);
[~, L_K, ~] = kalman(plant, estimator.Q_K, estimator.R_K);
