
% state feedback and terminal cost
[K, P]  = dlqr(system.A_heli, ...
               system.B_heli, ...
               cost.Q(1:system.n-1, 1:system.n-1), ...
               cost.R);
         
% extend to add system state d
system.K = [-K zeros(system.m, 1)];
cost.P = [P zeros(size(P,1), 1) ;
          zeros(1, size(P,1)+1)];
cost.P(system.n, system.n) = 0;      
      
% generate matrices Sx, Su
[Sx, Su] = genMPCprob(system.A,system.B,system.N); 
system.Sx = Sx;
system.Su = Su;



% calculate terminal constraint set 
% if already exists
if exist([pwd '\terminal_constraint.mat'], 'file') == 2
       load 'terminal_constraint.mat'
       constraints.G = X_f.A;
       constraints.h = X_f.b;
% if not, calculate    
else
       constraints.C_heli = [1 0 0 0 0 0; 
                            -1 0 0 0 0 0; 
                             0 0 1 0 0 0; 
                             0 0 -1 0 0 0;  
                            zeros(system.m, system.n-1)];
       constraints.D_heli = [ zeros(size(constraints.C,1) - system.m, system.m) ;
                            1 0; 
                            -1 0];
              
       constraints.e_heli = DEGTORAD * [c_travel;         c_travel; 
                                        c_pitch;          c_pitch; 
                                        c_pitch_ref;      c_pitch_ref];

       constraints.C_K_heli       = constraints.C_heli - constraints.D_heli * K;
       system.A_K_heli            = system.A_heli      - system.B_heli      * K;
       constraints.P              = Polyhedron('A', constraints.C_K_heli, 'b', constraints.e_heli);
       model_heli                 = LTISystem('A',system.A_K_heli);
       model_heli.x.with('setConstraint');
       model_heli.x.setConstraint = constraints.P;
       X_f_heli                   = model_heli.invariantSet();    
       % no terminal constraint on d, just zeros
       constraints.G = [X_f_heli.A, zeros(size(X_f_heli.A,1), 1)];
       constraints.h = X_f_heli.b;
       X_f = Polyhedron(constraints.G, constraints.h);
       save('terminal_constraint', 'X_f')
end    


   
