
t = 0:system.h:system.h*(system.Nsim-1);
t_end = round(t(size(t,2)));
color_mpc = 'b';
color_sim = 'k';
title_fig = 'Simulation of helicopter';
figure(1)
subplot(811)
plot(t,u(1,:), color_sim),grid
if (with_estimator)
    title_fig = [title_fig ' with estimator'];
        if (system.stable)
            title_fig = [title_fig ' and terminal cost and constraint'];
        end
else 
    if (system.stable)
        title_fig = [title_fig ' with terminal cost and constraint'];
    end        
end    
title(title_fig)
ylim1 = min(u(1,:)) - 0.03;
ylim2 = max(u(1,:)) + 0.05;
ylim([ylim1 ylim2]);
legend_u1 = ['$R_{11} =$ ', ' ', num2str(problem.cost.R(1,1))];
legend(legend_u1, 'Location', 'southeast');
ylabel('$p_c$ (rad)')
subplot(812)
plot(t,u(2,:), color_sim), grid
%ylabel('$e_c$')
ylim1 = min(u(2,:)) - 0.03;
ylim2 = max(u(2,:)) + 0.05;
ylim([ylim1 ylim2]);
legend_u2 = ['$R_{22}=$ ', ' ', num2str(problem.cost.R(2,2))];
legend(legend_u2, 'Location', 'southeast');
ylabel('$e_c$ (rad)')
subplot(813)
plot(t,x(1,:), color_sim, t, x_opt(1,:), color_mpc),grid
%hold on
%plot(t, w_sequence(1,:)), hold off
%ylabel('travel $\lambda$')
ylim1 = min(x(1,:)) - 0.2;
ylim2 = max(x(1,:)) + 0.2;
ylim([ylim1 ylim2])
legend_x1 = 'system state $\lambda$';
legend_x1_mpc = ['system state, $Q_{11}=$ ', ' ', num2str(problem.cost.Q(1,1)) ];
legend(legend_x1_mpc, 'optimal state', 'Location', 'southeast');
ylabel('$\lambda$ (rad)')
subplot(814)
plot(t,x(2,:), color_sim, t, x_opt(2,:), color_mpc),grid
ylim1 = min(x(2,:)) - 0.2;
ylim2 = max(x(2,:)) + 0.02;
ylim([ylim1 ylim2])
%ylabel('travel rate $r$')
legend_x2 = 'system state $\dot{\lambda}$';
legend_x2_mpc = ['system state, $Q_{22}=$ ', ' ', num2str(problem.cost.Q(2,2))];
legend(legend_x2_mpc, 'optimal state', 'Location', 'southeast');
ylabel('$\dot{\lambda}$ (rad/s)')
subplot(815)
plot(t,x(3,:), color_sim, t, x_opt(3,:), color_mpc),grid
ylim1 = min(x(3,:)) - 0.17;
ylim2 = max(x(3,:)) + 0.02;
ylim([ylim1 ylim2])
%ylabel('pitch $p$')
legend_x3 = 'system state $p$';
legend_x3_mpc = ['system state, $Q_{33}=$ ', ' ', num2str(problem.cost.Q(3,3))];
legend(legend_x3_mpc, 'optimal state', 'Location', 'southeast');
ylabel('$p$ (rad)')
subplot(816)
plot(t,x(4,:), color_sim, t, x_opt(4,:), color_mpc),grid
ylim1 = min(x(4,:)) - 0.001;
ylim2 = max(x(4,:)) + 0.001;
ylim([ylim1 ylim2])
%ylabel('pitch rate $\dot{p}$')
legend_x4 = 'system state $\dot{p}$';
legend_x4_mpc = ['system state, $Q_{44}=$ ', ' ',  num2str(problem.cost.Q(4,4))]; 
legend(legend_x4_mpc, 'optimal state', 'Location', 'southeast');
ylabel('$\dot p$ (rad/s)')
subplot(817)
plot(t,x(5,:), color_sim, t, x_opt(5,:), color_mpc),grid
%line([0, t_end], [e_lim, e_lim])
%line([0, t_end], [-e_lim, -e_lim])
ylim1 = min(x(5,:)) - 0.1;
ylim2 = max(x(5,:)) + 0.2;
ylim([ylim1 ylim2])
%ylabel('elevation $e$')
legend_x5 = 'system state $e$';
legend_x5_mpc = ['system state, $Q_{55}=$ ', ' ', num2str(problem.cost.Q(5,5))];
legend(legend_x5_mpc, 'optimal state', 'Location', 'southeast');
ylabel('$e$ (rad')
subplot(818)
plot(t,x(6,:), color_sim, t, x_opt(6,:), color_mpc),grid
ylim1 = min(x(6,:)) - 0.01;
ylim2 = max(x(6,:)) + 0.01;
ylim([ylim1 ylim2])
legend_x6 = 'system state $\dot{e}$';
legend_x6_mpc = ['system state, $Q_{66}=$ ', ' ', num2str(problem.cost.Q(6,6))];
legend(legend_x6_mpc, 'optimal state', 'Location', 'southeast');
xlabel('time (s)')
ylabel('$\dot e$ (rad/s)')
clear legend_u1 legend_u2 legend_x1 legend_x1_mpc legend_x2 legend_x2_mpc legend_x3 ...
      legend_x3_mpc legend_x4 legend_x4_mpc legend_x5 legend_x5_mpc legend_x6 legend_x6_mpc ylim1 ylim2